#ifndef SHAPE_SHP_H__
#define SHAPE_SHP_H__

#ifndef LE_TO_BE_INT
#define LE_TO_BE_INT(x) (((x) >> 24) | ((x) << 24) | (((x) >> 8) & 0xff00) | (((x) << 8) & 0xff0000))
#endif

#ifndef BE_TO_LE_INT
#define BE_TO_LE_INT(x) LE_TO_BE_INT(x)
#endif

#pragma pack(push,1)

struct shp_file_header {
	shp_file_header(int file_length, int width, int height)
	{
		// Big
		FileCode	= LE_TO_BE_INT(9994);
		Reserved0	= 0;
		Reserved1	= 0;
		Reserved2	= 0;
		Reserved3	= 0;
		Reserved4	= 0;
		FileLength  = LE_TO_BE_INT(file_length / 2);
		// Little
		Version		= 1000;
		ShapeType   = 1;
		Xmin		= 0.0;
		Ymin		= 0.0;
		Xmax		= (width) ? width : 1;
		Ymax		= (height) ? height : 1;
		Zmin		= 0.0;
		Zmax		= 0.0;
		Mmin		= 0.0;
		Mmax		= 0.0;
	}

	int		FileCode;	// Big
	int		Reserved0;	// Big
	int		Reserved1;	// Big
	int		Reserved2;	// Big
	int		Reserved3;	// Big
	int		Reserved4;	// Big
	int		FileLength;	// Big
	int		Version;
	int		ShapeType;
	double	Xmin;
	double	Ymin;
	double	Xmax;
	double	Ymax;
	double	Zmin;
	double	Zmax;
	double	Mmin;
	double	Mmax;
};



#pragma pack(pop)


#endif


